
// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventing.py

******************************************************************/
#include <common.h>
#include <PalRedhawk.h>
#include "clretwallmain.h"
#include "clreventpipewriteevents.h"
#ifdef FEATURE_ETW
#include "ClrEtwAll.h"
#endif

BOOL EventEnabledGCStart_V2(void) {return EventPipeEventEnabledGCStart_V2();}

ULONG FireEtwGCStart_V2(
    const unsigned int  Count,
    const unsigned int  Depth,
    const unsigned int  Reason,
    const unsigned int  Type,
    const unsigned short  ClrInstanceID,
    const uint64_t  ClientSequenceNumber,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCStart_V2(Count,Depth,Reason,Type,ClrInstanceID,ClientSequenceNumber,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCStart_V2(Count,Depth,Reason,Type,ClrInstanceID,ClientSequenceNumber);
#endif
    return status;
}

BOOL EventEnabledGCEnd_V1(void) {return EventPipeEventEnabledGCEnd_V1();}

ULONG FireEtwGCEnd_V1(
    const unsigned int  Count,
    const unsigned int  Depth,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCEnd_V1(Count,Depth,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCEnd_V1(Count,Depth,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCRestartEEEnd_V1(void) {return EventPipeEventEnabledGCRestartEEEnd_V1();}

ULONG FireEtwGCRestartEEEnd_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCRestartEEEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCRestartEEEnd_V1(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCHeapStats_V2(void) {return EventPipeEventEnabledGCHeapStats_V2();}

ULONG FireEtwGCHeapStats_V2(
    const uint64_t  GenerationSize0,
    const uint64_t  TotalPromotedSize0,
    const uint64_t  GenerationSize1,
    const uint64_t  TotalPromotedSize1,
    const uint64_t  GenerationSize2,
    const uint64_t  TotalPromotedSize2,
    const uint64_t  GenerationSize3,
    const uint64_t  TotalPromotedSize3,
    const uint64_t  FinalizationPromotedSize,
    const uint64_t  FinalizationPromotedCount,
    const unsigned int  PinnedObjectCount,
    const unsigned int  SinkBlockCount,
    const unsigned int  GCHandleCount,
    const unsigned short  ClrInstanceID,
    const uint64_t  GenerationSize4,
    const uint64_t  TotalPromotedSize4,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCHeapStats_V2(GenerationSize0,TotalPromotedSize0,GenerationSize1,TotalPromotedSize1,GenerationSize2,TotalPromotedSize2,GenerationSize3,TotalPromotedSize3,FinalizationPromotedSize,FinalizationPromotedCount,PinnedObjectCount,SinkBlockCount,GCHandleCount,ClrInstanceID,GenerationSize4,TotalPromotedSize4,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCHeapStats_V2(GenerationSize0,TotalPromotedSize0,GenerationSize1,TotalPromotedSize1,GenerationSize2,TotalPromotedSize2,GenerationSize3,TotalPromotedSize3,FinalizationPromotedSize,FinalizationPromotedCount,PinnedObjectCount,SinkBlockCount,GCHandleCount,ClrInstanceID,GenerationSize4,TotalPromotedSize4);
#endif
    return status;
}

BOOL EventEnabledGCCreateSegment_V1(void) {return EventPipeEventEnabledGCCreateSegment_V1();}

ULONG FireEtwGCCreateSegment_V1(
    const uint64_t  Address,
    const uint64_t  Size,
    const unsigned int  Type,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCCreateSegment_V1(Address,Size,Type,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCCreateSegment_V1(Address,Size,Type,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCFreeSegment_V1(void) {return EventPipeEventEnabledGCFreeSegment_V1();}

ULONG FireEtwGCFreeSegment_V1(
    const uint64_t  Address,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCFreeSegment_V1(Address,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCFreeSegment_V1(Address,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCRestartEEBegin_V1(void) {return EventPipeEventEnabledGCRestartEEBegin_V1();}

ULONG FireEtwGCRestartEEBegin_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCRestartEEBegin_V1(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCRestartEEBegin_V1(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCSuspendEEEnd_V1(void) {return EventPipeEventEnabledGCSuspendEEEnd_V1();}

ULONG FireEtwGCSuspendEEEnd_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCSuspendEEEnd_V1(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCSuspendEEEnd_V1(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCSuspendEEBegin_V1(void) {return EventPipeEventEnabledGCSuspendEEBegin_V1();}

ULONG FireEtwGCSuspendEEBegin_V1(
    const unsigned int  Reason,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCSuspendEEBegin_V1(Reason,Count,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCSuspendEEBegin_V1(Reason,Count,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCAllocationTick_V4(void) {return EventPipeEventEnabledGCAllocationTick_V4();}

ULONG FireEtwGCAllocationTick_V4(
    const unsigned int  AllocationAmount,
    const unsigned int  AllocationKind,
    const unsigned short  ClrInstanceID,
    const uint64_t  AllocationAmount64,
    const void*  TypeID,
    const WCHAR*  TypeName,
    const unsigned int  HeapIndex,
    const void*  Address,
    const uint64_t  ObjectSize,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCAllocationTick_V4(AllocationAmount,AllocationKind,ClrInstanceID,AllocationAmount64,TypeID,TypeName,HeapIndex,Address,ObjectSize,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCAllocationTick_V4(AllocationAmount,AllocationKind,ClrInstanceID,AllocationAmount64,TypeID,TypeName,HeapIndex,Address,ObjectSize);
#endif
    return status;
}

BOOL EventEnabledGCCreateConcurrentThread_V1(void) {return EventPipeEventEnabledGCCreateConcurrentThread_V1();}

ULONG FireEtwGCCreateConcurrentThread_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCCreateConcurrentThread_V1(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCCreateConcurrentThread_V1(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCTerminateConcurrentThread_V1(void) {return EventPipeEventEnabledGCTerminateConcurrentThread_V1();}

ULONG FireEtwGCTerminateConcurrentThread_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCTerminateConcurrentThread_V1(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCTerminateConcurrentThread_V1(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCFinalizersEnd_V1(void) {return EventPipeEventEnabledGCFinalizersEnd_V1();}

ULONG FireEtwGCFinalizersEnd_V1(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCFinalizersEnd_V1(Count,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCFinalizersEnd_V1(Count,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCFinalizersBegin_V1(void) {return EventPipeEventEnabledGCFinalizersBegin_V1();}

ULONG FireEtwGCFinalizersBegin_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCFinalizersBegin_V1(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCFinalizersBegin_V1(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBulkType(void) {return EventPipeEventEnabledBulkType();}

ULONG FireEtwBulkType(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBulkType(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBulkType(Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkRootEdge(void) {return EventPipeEventEnabledGCBulkRootEdge();}

ULONG FireEtwGCBulkRootEdge(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkRootEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkRootEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkRootConditionalWeakTableElementEdge(void) {return EventPipeEventEnabledGCBulkRootConditionalWeakTableElementEdge();}

ULONG FireEtwGCBulkRootConditionalWeakTableElementEdge(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkRootConditionalWeakTableElementEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkRootConditionalWeakTableElementEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkNode(void) {return EventPipeEventEnabledGCBulkNode();}

ULONG FireEtwGCBulkNode(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkNode(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkNode(Index,Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkEdge(void) {return EventPipeEventEnabledGCBulkEdge();}

ULONG FireEtwGCBulkEdge(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkEdge(Index,Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCSampledObjectAllocationHigh(void) {return EventPipeEventEnabledGCSampledObjectAllocationHigh();}

ULONG FireEtwGCSampledObjectAllocationHigh(
    const void*  Address,
    const void*  TypeID,
    const unsigned int  ObjectCountForTypeSample,
    const uint64_t  TotalSizeForTypeSample,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCSampledObjectAllocationHigh(Address,TypeID,ObjectCountForTypeSample,TotalSizeForTypeSample,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCSampledObjectAllocationHigh(Address,TypeID,ObjectCountForTypeSample,TotalSizeForTypeSample,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCBulkSurvivingObjectRanges(void) {return EventPipeEventEnabledGCBulkSurvivingObjectRanges();}

ULONG FireEtwGCBulkSurvivingObjectRanges(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkSurvivingObjectRanges(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkSurvivingObjectRanges(Index,Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkMovedObjectRanges(void) {return EventPipeEventEnabledGCBulkMovedObjectRanges();}

ULONG FireEtwGCBulkMovedObjectRanges(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkMovedObjectRanges(Index,Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkMovedObjectRanges(Index,Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCGenerationRange(void) {return EventPipeEventEnabledGCGenerationRange();}

ULONG FireEtwGCGenerationRange(
    const unsigned char  Generation,
    const void*  RangeStart,
    const uint64_t  RangeUsedLength,
    const uint64_t  RangeReservedLength,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCGenerationRange(Generation,RangeStart,RangeUsedLength,RangeReservedLength,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCGenerationRange(Generation,RangeStart,RangeUsedLength,RangeReservedLength,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCMarkStackRoots(void) {return EventPipeEventEnabledGCMarkStackRoots();}

ULONG FireEtwGCMarkStackRoots(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCMarkStackRoots(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCMarkStackRoots(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCMarkFinalizeQueueRoots(void) {return EventPipeEventEnabledGCMarkFinalizeQueueRoots();}

ULONG FireEtwGCMarkFinalizeQueueRoots(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCMarkFinalizeQueueRoots(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCMarkFinalizeQueueRoots(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCMarkHandles(void) {return EventPipeEventEnabledGCMarkHandles();}

ULONG FireEtwGCMarkHandles(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCMarkHandles(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCMarkHandles(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCMarkOlderGenerationRoots(void) {return EventPipeEventEnabledGCMarkOlderGenerationRoots();}

ULONG FireEtwGCMarkOlderGenerationRoots(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCMarkOlderGenerationRoots(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCMarkOlderGenerationRoots(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledFinalizeObject(void) {return EventPipeEventEnabledFinalizeObject();}

ULONG FireEtwFinalizeObject(
    const void*  TypeID,
    const void*  ObjectID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventFinalizeObject(TypeID,ObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatFinalizeObject(TypeID,ObjectID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledSetGCHandle(void) {return EventPipeEventEnabledSetGCHandle();}

ULONG FireEtwSetGCHandle(
    const void*  HandleID,
    const void*  ObjectID,
    const unsigned int  Kind,
    const unsigned int  Generation,
    const uint64_t  AppDomainID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventSetGCHandle(HandleID,ObjectID,Kind,Generation,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatSetGCHandle(HandleID,ObjectID,Kind,Generation,AppDomainID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledDestroyGCHandle(void) {return EventPipeEventEnabledDestroyGCHandle();}

ULONG FireEtwDestroyGCHandle(
    const void*  HandleID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventDestroyGCHandle(HandleID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatDestroyGCHandle(HandleID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCSampledObjectAllocationLow(void) {return EventPipeEventEnabledGCSampledObjectAllocationLow();}

ULONG FireEtwGCSampledObjectAllocationLow(
    const void*  Address,
    const void*  TypeID,
    const unsigned int  ObjectCountForTypeSample,
    const uint64_t  TotalSizeForTypeSample,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCSampledObjectAllocationLow(Address,TypeID,ObjectCountForTypeSample,TotalSizeForTypeSample,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCSampledObjectAllocationLow(Address,TypeID,ObjectCountForTypeSample,TotalSizeForTypeSample,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPinObjectAtGCTime(void) {return EventPipeEventEnabledPinObjectAtGCTime();}

ULONG FireEtwPinObjectAtGCTime(
    const void*  HandleID,
    const void*  ObjectID,
    const uint64_t  ObjectSize,
    const WCHAR*  TypeName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPinObjectAtGCTime(HandleID,ObjectID,ObjectSize,TypeName,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPinObjectAtGCTime(HandleID,ObjectID,ObjectSize,TypeName,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCTriggered(void) {return EventPipeEventEnabledGCTriggered();}

ULONG FireEtwGCTriggered(
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCTriggered(Reason,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCTriggered(Reason,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCBulkRootCCW(void) {return EventPipeEventEnabledGCBulkRootCCW();}

ULONG FireEtwGCBulkRootCCW(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkRootCCW(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkRootCCW(Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkRCW(void) {return EventPipeEventEnabledGCBulkRCW();}

ULONG FireEtwGCBulkRCW(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkRCW(Count,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkRCW(Count,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCBulkRootStaticVar(void) {return EventPipeEventEnabledGCBulkRootStaticVar();}

ULONG FireEtwGCBulkRootStaticVar(
    const unsigned int  Count,
    const uint64_t  AppDomainID,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCBulkRootStaticVar(Count,AppDomainID,ClrInstanceID,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCBulkRootStaticVar(Count,AppDomainID,ClrInstanceID,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCDynamicEvent(void) {return EventPipeEventEnabledGCDynamicEvent();}

ULONG FireEtwGCDynamicEvent(
    const WCHAR*  Name,
    const unsigned int  DataSize,
    const BYTE* Data,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCDynamicEvent(Name,DataSize,Data,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCDynamicEvent(Name,DataSize,Data,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadpoolSuspensionSuspendThread(void) {return EventPipeEventEnabledThreadpoolSuspensionSuspendThread();}

ULONG FireEtwThreadpoolSuspensionSuspendThread(
    const unsigned int  ClrThreadID,
    const unsigned int  CpuUtilization,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadpoolSuspensionSuspendThread(ClrThreadID,CpuUtilization,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadpoolSuspensionSuspendThread(ClrThreadID,CpuUtilization);
#endif
    return status;
}

BOOL EventEnabledThreadpoolSuspensionResumeThread(void) {return EventPipeEventEnabledThreadpoolSuspensionResumeThread();}

ULONG FireEtwThreadpoolSuspensionResumeThread(
    const unsigned int  ClrThreadID,
    const unsigned int  CpuUtilization,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadpoolSuspensionResumeThread(ClrThreadID,CpuUtilization,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadpoolSuspensionResumeThread(ClrThreadID,CpuUtilization);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadStart(void) {return EventPipeEventEnabledThreadPoolWorkerThreadStart();}

ULONG FireEtwThreadPoolWorkerThreadStart(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadStop(void) {return EventPipeEventEnabledThreadPoolWorkerThreadStop();}

ULONG FireEtwThreadPoolWorkerThreadStop(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadRetirementStart(void) {return EventPipeEventEnabledThreadPoolWorkerThreadRetirementStart();}

ULONG FireEtwThreadPoolWorkerThreadRetirementStart(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadRetirementStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadRetirementStart(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadRetirementStop(void) {return EventPipeEventEnabledThreadPoolWorkerThreadRetirementStop();}

ULONG FireEtwThreadPoolWorkerThreadRetirementStop(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadRetirementStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadRetirementStop(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadAdjustmentSample(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentSample();}

ULONG FireEtwThreadPoolWorkerThreadAdjustmentSample(
    const double  Throughput,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentSample(Throughput,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadAdjustmentSample(Throughput,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadAdjustmentAdjustment(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentAdjustment();}

ULONG FireEtwThreadPoolWorkerThreadAdjustmentAdjustment(
    const double  AverageThroughput,
    const unsigned int  NewWorkerThreadCount,
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentAdjustment(AverageThroughput,NewWorkerThreadCount,Reason,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadAdjustmentAdjustment(AverageThroughput,NewWorkerThreadCount,Reason,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadAdjustmentStats(void) {return EventPipeEventEnabledThreadPoolWorkerThreadAdjustmentStats();}

ULONG FireEtwThreadPoolWorkerThreadAdjustmentStats(
    const double  Duration,
    const double  Throughput,
    const double  ThreadWave,
    const double  ThroughputWave,
    const double  ThroughputErrorEstimate,
    const double  AverageThroughputErrorEstimate,
    const double  ThroughputRatio,
    const double  Confidence,
    const double  NewControlSetting,
    const unsigned short  NewThreadWaveMagnitude,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadAdjustmentStats(Duration,Throughput,ThreadWave,ThroughputWave,ThroughputErrorEstimate,AverageThroughputErrorEstimate,ThroughputRatio,Confidence,NewControlSetting,NewThreadWaveMagnitude,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadAdjustmentStats(Duration,Throughput,ThreadWave,ThroughputWave,ThroughputErrorEstimate,AverageThroughputErrorEstimate,ThroughputRatio,Confidence,NewControlSetting,NewThreadWaveMagnitude,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkerThreadWait(void) {return EventPipeEventEnabledThreadPoolWorkerThreadWait();}

ULONG FireEtwThreadPoolWorkerThreadWait(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkerThreadWait(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkerThreadWait(ActiveWorkerThreadCount,RetiredWorkerThreadCount,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledYieldProcessorMeasurement(void) {return EventPipeEventEnabledYieldProcessorMeasurement();}

ULONG FireEtwYieldProcessorMeasurement(
    const unsigned short  ClrInstanceID,
    const double  NsPerYield,
    const double  EstablishedNsPerYield,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventYieldProcessorMeasurement(ClrInstanceID,NsPerYield,EstablishedNsPerYield,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatYieldProcessorMeasurement(ClrInstanceID,NsPerYield,EstablishedNsPerYield);
#endif
    return status;
}

BOOL EventEnabledThreadPoolMinMaxThreads(void) {return EventPipeEventEnabledThreadPoolMinMaxThreads();}

ULONG FireEtwThreadPoolMinMaxThreads(
    const unsigned short  MinWorkerThreads,
    const unsigned short  MaxWorkerThreads,
    const unsigned short  MinIOCompletionThreads,
    const unsigned short  MaxIOCompletionThreads,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolMinMaxThreads(MinWorkerThreads,MaxWorkerThreads,MinIOCompletionThreads,MaxIOCompletionThreads,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolMinMaxThreads(MinWorkerThreads,MaxWorkerThreads,MinIOCompletionThreads,MaxIOCompletionThreads,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolWorkingThreadCount(void) {return EventPipeEventEnabledThreadPoolWorkingThreadCount();}

ULONG FireEtwThreadPoolWorkingThreadCount(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolWorkingThreadCount(Count,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolWorkingThreadCount(Count,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolEnqueue(void) {return EventPipeEventEnabledThreadPoolEnqueue();}

ULONG FireEtwThreadPoolEnqueue(
    const void*  WorkID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolEnqueue(WorkID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolEnqueue(WorkID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolDequeue(void) {return EventPipeEventEnabledThreadPoolDequeue();}

ULONG FireEtwThreadPoolDequeue(
    const void*  WorkID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolDequeue(WorkID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolDequeue(WorkID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolIOEnqueue(void) {return EventPipeEventEnabledThreadPoolIOEnqueue();}

ULONG FireEtwThreadPoolIOEnqueue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const BOOL  MultiDequeues,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolIOEnqueue(NativeOverlapped,Overlapped,MultiDequeues,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolIOEnqueue(NativeOverlapped,Overlapped,MultiDequeues,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolIODequeue(void) {return EventPipeEventEnabledThreadPoolIODequeue();}

ULONG FireEtwThreadPoolIODequeue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolIODequeue(NativeOverlapped,Overlapped,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolIODequeue(NativeOverlapped,Overlapped,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadPoolIOPack(void) {return EventPipeEventEnabledThreadPoolIOPack();}

ULONG FireEtwThreadPoolIOPack(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadPoolIOPack(NativeOverlapped,Overlapped,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadPoolIOPack(NativeOverlapped,Overlapped,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadCreating(void) {return EventPipeEventEnabledThreadCreating();}

ULONG FireEtwThreadCreating(
    const void*  ID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadCreating(ID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadCreating(ID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadRunning(void) {return EventPipeEventEnabledThreadRunning();}

ULONG FireEtwThreadRunning(
    const void*  ID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadRunning(ID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadRunning(ID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledExceptionThrown_V1(void) {return EventPipeEventEnabledExceptionThrown_V1();}

ULONG FireEtwExceptionThrown_V1(
    const WCHAR*  ExceptionType,
    const WCHAR*  ExceptionMessage,
    const void*  ExceptionEIP,
    const unsigned int  ExceptionHRESULT,
    const unsigned short  ExceptionFlags,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionThrown_V1(ExceptionType,ExceptionMessage,ExceptionEIP,ExceptionHRESULT,ExceptionFlags,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionThrown_V1(ExceptionType,ExceptionMessage,ExceptionEIP,ExceptionHRESULT,ExceptionFlags,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledExceptionCatchStart(void) {return EventPipeEventEnabledExceptionCatchStart();}

ULONG FireEtwExceptionCatchStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const WCHAR*  MethodName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionCatchStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionCatchStart(EntryEIP,MethodID,MethodName,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledExceptionCatchStop(void) {return EventPipeEventEnabledExceptionCatchStop();}

ULONG FireEtwExceptionCatchStop(
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionCatchStop(ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionCatchStop();
#endif
    return status;
}

BOOL EventEnabledExceptionFinallyStart(void) {return EventPipeEventEnabledExceptionFinallyStart();}

ULONG FireEtwExceptionFinallyStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const WCHAR*  MethodName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionFinallyStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionFinallyStart(EntryEIP,MethodID,MethodName,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledExceptionFinallyStop(void) {return EventPipeEventEnabledExceptionFinallyStop();}

ULONG FireEtwExceptionFinallyStop(
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionFinallyStop(ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionFinallyStop();
#endif
    return status;
}

BOOL EventEnabledExceptionFilterStart(void) {return EventPipeEventEnabledExceptionFilterStart();}

ULONG FireEtwExceptionFilterStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const WCHAR*  MethodName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionFilterStart(EntryEIP,MethodID,MethodName,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionFilterStart(EntryEIP,MethodID,MethodName,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledExceptionFilterStop(void) {return EventPipeEventEnabledExceptionFilterStop();}

ULONG FireEtwExceptionFilterStop(
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionFilterStop(ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionFilterStop();
#endif
    return status;
}

BOOL EventEnabledExceptionThrownStop(void) {return EventPipeEventEnabledExceptionThrownStop();}

ULONG FireEtwExceptionThrownStop(
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExceptionThrownStop(ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExceptionThrownStop();
#endif
    return status;
}

BOOL EventEnabledContention(void) {return EventPipeEventEnabledContention();}

ULONG FireEtwContention(
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventContention(ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatContention();
#endif
    return status;
}

BOOL EventEnabledContentionStart_V2(void) {return EventPipeEventEnabledContentionStart_V2();}

ULONG FireEtwContentionStart_V2(
    const unsigned char  ContentionFlags,
    const unsigned short  ClrInstanceID,
    const void*  LockID,
    const void*  AssociatedObjectID,
    const uint64_t  LockOwnerThreadID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventContentionStart_V2(ContentionFlags,ClrInstanceID,LockID,AssociatedObjectID,LockOwnerThreadID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatContentionStart_V2(ContentionFlags,ClrInstanceID,LockID,AssociatedObjectID,LockOwnerThreadID);
#endif
    return status;
}

BOOL EventEnabledContentionStop_V1(void) {return EventPipeEventEnabledContentionStop_V1();}

ULONG FireEtwContentionStop_V1(
    const unsigned char  ContentionFlags,
    const unsigned short  ClrInstanceID,
    const double  DurationNs,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventContentionStop_V1(ContentionFlags,ClrInstanceID,DurationNs,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatContentionStop_V1(ContentionFlags,ClrInstanceID,DurationNs);
#endif
    return status;
}

BOOL EventEnabledContentionLockCreated(void) {return EventPipeEventEnabledContentionLockCreated();}

ULONG FireEtwContentionLockCreated(
    const void*  LockID,
    const void*  AssociatedObjectID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventContentionLockCreated(LockID,AssociatedObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatContentionLockCreated(LockID,AssociatedObjectID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledThreadCreated(void) {return EventPipeEventEnabledThreadCreated();}

ULONG FireEtwThreadCreated(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const unsigned int  Flags,
    const unsigned int  ManagedThreadIndex,
    const unsigned int  OSThreadID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventThreadCreated(ManagedThreadID,AppDomainID,Flags,ManagedThreadIndex,OSThreadID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatThreadCreated(ManagedThreadID,AppDomainID,Flags,ManagedThreadIndex,OSThreadID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledModuleLoad_V2(void) {return EventPipeEventEnabledModuleLoad_V2();}

ULONG FireEtwModuleLoad_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const unsigned int  ModuleFlags,
    const unsigned int  Reserved1,
    const WCHAR*  ModuleILPath,
    const WCHAR*  ModuleNativePath,
    const unsigned short  ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int  ManagedPdbAge,
    const WCHAR*  ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int  NativePdbAge,
    const WCHAR*  NativePdbBuildPath,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventModuleLoad_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatModuleLoad_V2(ModuleID,AssemblyID,ModuleFlags,Reserved1,ModuleILPath,ModuleNativePath,ClrInstanceID,ManagedPdbSignature,ManagedPdbAge,ManagedPdbBuildPath,NativePdbSignature,NativePdbAge,NativePdbBuildPath);
#endif
    return status;
}

BOOL EventEnabledIncreaseMemoryPressure(void) {return EventPipeEventEnabledIncreaseMemoryPressure();}

ULONG FireEtwIncreaseMemoryPressure(
    const uint64_t  BytesAllocated,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventIncreaseMemoryPressure(BytesAllocated,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatIncreaseMemoryPressure(BytesAllocated,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledDecreaseMemoryPressure(void) {return EventPipeEventEnabledDecreaseMemoryPressure();}

ULONG FireEtwDecreaseMemoryPressure(
    const uint64_t  BytesFreed,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventDecreaseMemoryPressure(BytesFreed,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatDecreaseMemoryPressure(BytesFreed,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCMarkWithType(void) {return EventPipeEventEnabledGCMarkWithType();}

ULONG FireEtwGCMarkWithType(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const unsigned int  Type,
    const uint64_t  Bytes,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCMarkWithType(HeapNum,ClrInstanceID,Type,Bytes,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCMarkWithType(HeapNum,ClrInstanceID,Type,Bytes);
#endif
    return status;
}

BOOL EventEnabledGCJoin_V2(void) {return EventPipeEventEnabledGCJoin_V2();}

ULONG FireEtwGCJoin_V2(
    const unsigned int  Heap,
    const unsigned int  JoinTime,
    const unsigned int  JoinType,
    const unsigned short  ClrInstanceID,
    const unsigned int  JoinID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCJoin_V2(Heap,JoinTime,JoinType,ClrInstanceID,JoinID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCJoin_V2(Heap,JoinTime,JoinType,ClrInstanceID,JoinID);
#endif
    return status;
}

BOOL EventEnabledGCPerHeapHistory_V3(void) {return EventPipeEventEnabledGCPerHeapHistory_V3();}

ULONG FireEtwGCPerHeapHistory_V3(
    const unsigned short  ClrInstanceID,
    const void*  FreeListAllocated,
    const void*  FreeListRejected,
    const void*  EndOfSegAllocated,
    const void*  CondemnedAllocated,
    const void*  PinnedAllocated,
    const void*  PinnedAllocatedAdvance,
    const unsigned int  RunningFreeListEfficiency,
    const unsigned int  CondemnReasons0,
    const unsigned int  CondemnReasons1,
    const unsigned int  CompactMechanisms,
    const unsigned int  ExpandMechanisms,
    const unsigned int  HeapIndex,
    const void*  ExtraGen0Commit,
    const unsigned int  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCPerHeapHistory_V3(ClrInstanceID,FreeListAllocated,FreeListRejected,EndOfSegAllocated,CondemnedAllocated,PinnedAllocated,PinnedAllocatedAdvance,RunningFreeListEfficiency,CondemnReasons0,CondemnReasons1,CompactMechanisms,ExpandMechanisms,HeapIndex,ExtraGen0Commit,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCPerHeapHistory_V3(ClrInstanceID,FreeListAllocated,FreeListRejected,EndOfSegAllocated,CondemnedAllocated,PinnedAllocated,PinnedAllocatedAdvance,RunningFreeListEfficiency,CondemnReasons0,CondemnReasons1,CompactMechanisms,ExpandMechanisms,HeapIndex,ExtraGen0Commit,Count,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCGlobalHeapHistory_V4(void) {return EventPipeEventEnabledGCGlobalHeapHistory_V4();}

ULONG FireEtwGCGlobalHeapHistory_V4(
    const uint64_t  FinalYoungestDesired,
    const signed int  NumHeaps,
    const unsigned int  CondemnedGeneration,
    const unsigned int  Gen0ReductionCount,
    const unsigned int  Reason,
    const unsigned int  GlobalMechanisms,
    const unsigned short  ClrInstanceID,
    const unsigned int  PauseMode,
    const unsigned int  MemoryPressure,
    const unsigned int  CondemnReasons0,
    const unsigned int  CondemnReasons1,
    const unsigned int  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCGlobalHeapHistory_V4(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ClrInstanceID,PauseMode,MemoryPressure,CondemnReasons0,CondemnReasons1,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCGlobalHeapHistory_V4(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ClrInstanceID,PauseMode,MemoryPressure,CondemnReasons0,CondemnReasons1,Count,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGenAwareBegin(void) {return EventPipeEventEnabledGenAwareBegin();}

ULONG FireEtwGenAwareBegin(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGenAwareBegin(Count,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGenAwareBegin(Count,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGenAwareEnd(void) {return EventPipeEventEnabledGenAwareEnd();}

ULONG FireEtwGenAwareEnd(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGenAwareEnd(Count,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGenAwareEnd(Count,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCLOHCompact(void) {return EventPipeEventEnabledGCLOHCompact();}

ULONG FireEtwGCLOHCompact(
    const unsigned short  ClrInstanceID,
    const unsigned short  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCLOHCompact(ClrInstanceID,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCLOHCompact(ClrInstanceID,Count,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledGCFitBucketInfo(void) {return EventPipeEventEnabledGCFitBucketInfo();}

ULONG FireEtwGCFitBucketInfo(
    const unsigned short  ClrInstanceID,
    const unsigned short  BucketKind,
    const uint64_t  TotalSize,
    const unsigned short  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCFitBucketInfo(ClrInstanceID,BucketKind,TotalSize,Count,Values_ElementSize, Values,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCFitBucketInfo(ClrInstanceID,BucketKind,TotalSize,Count,Values_ElementSize, Values);
#endif
    return status;
}

BOOL EventEnabledExecutionCheckpoint(void) {return EventPipeEventEnabledExecutionCheckpoint();}

ULONG FireEtwExecutionCheckpoint(
    const unsigned short  ClrInstanceID,
    const WCHAR*  Name,
    const int64_t  Timestamp,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventExecutionCheckpoint(ClrInstanceID,Name,Timestamp,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatExecutionCheckpoint(ClrInstanceID,Name,Timestamp);
#endif
    return status;
}

BOOL EventEnabledWaitHandleWaitStart(void) {return EventPipeEventEnabledWaitHandleWaitStart();}

ULONG FireEtwWaitHandleWaitStart(
    const unsigned char  WaitSource,
    const void*  AssociatedObjectID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventWaitHandleWaitStart(WaitSource,AssociatedObjectID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatWaitHandleWaitStart(WaitSource,AssociatedObjectID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledWaitHandleWaitStop(void) {return EventPipeEventEnabledWaitHandleWaitStop();}

ULONG FireEtwWaitHandleWaitStop(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventWaitHandleWaitStop(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatWaitHandleWaitStop(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCDecision_V1(void) {return EventPipeEventEnabledGCDecision_V1();}

ULONG FireEtwGCDecision_V1(
    const BOOL  DoCompact,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCDecision_V1(DoCompact,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCDecision_V1(DoCompact,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCSettings_V1(void) {return EventPipeEventEnabledGCSettings_V1();}

ULONG FireEtwGCSettings_V1(
    const uint64_t  SegmentSize,
    const uint64_t  LargeObjectSegmentSize,
    const BOOL  ServerGC,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCSettings_V1(SegmentSize,LargeObjectSegmentSize,ServerGC,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCSettings_V1(SegmentSize,LargeObjectSegmentSize,ServerGC,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCOptimized_V1(void) {return EventPipeEventEnabledGCOptimized_V1();}

ULONG FireEtwGCOptimized_V1(
    const uint64_t  DesiredAllocation,
    const uint64_t  NewAllocation,
    const unsigned int  GenerationNumber,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCOptimized_V1(DesiredAllocation,NewAllocation,GenerationNumber,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCOptimized_V1(DesiredAllocation,NewAllocation,GenerationNumber,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCGlobalHeapHistory(void) {return EventPipeEventEnabledGCGlobalHeapHistory();}

ULONG FireEtwGCGlobalHeapHistory(
    const uint64_t  FinalYoungestDesired,
    const signed int  NumHeaps,
    const unsigned int  CondemnedGeneration,
    const unsigned int  Gen0ReductionCount,
    const unsigned int  Reason,
    const unsigned int  GlobalMechanisms,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCGlobalHeapHistory(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCGlobalHeapHistory(FinalYoungestDesired,NumHeaps,CondemnedGeneration,Gen0ReductionCount,Reason,GlobalMechanisms);
#endif
    return status;
}

BOOL EventEnabledPrvGCMarkStackRoots_V1(void) {return EventPipeEventEnabledPrvGCMarkStackRoots_V1();}

ULONG FireEtwPrvGCMarkStackRoots_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvGCMarkStackRoots_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvGCMarkStackRoots_V1(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPrvGCMarkFinalizeQueueRoots_V1(void) {return EventPipeEventEnabledPrvGCMarkFinalizeQueueRoots_V1();}

ULONG FireEtwPrvGCMarkFinalizeQueueRoots_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvGCMarkFinalizeQueueRoots_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvGCMarkFinalizeQueueRoots_V1(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPrvGCMarkHandles_V1(void) {return EventPipeEventEnabledPrvGCMarkHandles_V1();}

ULONG FireEtwPrvGCMarkHandles_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvGCMarkHandles_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvGCMarkHandles_V1(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPrvGCMarkCards_V1(void) {return EventPipeEventEnabledPrvGCMarkCards_V1();}

ULONG FireEtwPrvGCMarkCards_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvGCMarkCards_V1(HeapNum,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvGCMarkCards_V1(HeapNum,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCBegin(void) {return EventPipeEventEnabledBGCBegin();}

ULONG FireEtwBGCBegin(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCBegin(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCBegin(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC1stNonConEnd(void) {return EventPipeEventEnabledBGC1stNonConEnd();}

ULONG FireEtwBGC1stNonConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC1stNonConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC1stNonConEnd(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC1stConEnd(void) {return EventPipeEventEnabledBGC1stConEnd();}

ULONG FireEtwBGC1stConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC1stConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC1stConEnd(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC2ndNonConBegin(void) {return EventPipeEventEnabledBGC2ndNonConBegin();}

ULONG FireEtwBGC2ndNonConBegin(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC2ndNonConBegin(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC2ndNonConBegin(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC2ndNonConEnd(void) {return EventPipeEventEnabledBGC2ndNonConEnd();}

ULONG FireEtwBGC2ndNonConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC2ndNonConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC2ndNonConEnd(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC2ndConBegin(void) {return EventPipeEventEnabledBGC2ndConBegin();}

ULONG FireEtwBGC2ndConBegin(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC2ndConBegin(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC2ndConBegin(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC2ndConEnd(void) {return EventPipeEventEnabledBGC2ndConEnd();}

ULONG FireEtwBGC2ndConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC2ndConEnd(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC2ndConEnd(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCPlanEnd(void) {return EventPipeEventEnabledBGCPlanEnd();}

ULONG FireEtwBGCPlanEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCPlanEnd(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCPlanEnd(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCSweepEnd(void) {return EventPipeEventEnabledBGCSweepEnd();}

ULONG FireEtwBGCSweepEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCSweepEnd(ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCSweepEnd(ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCDrainMark(void) {return EventPipeEventEnabledBGCDrainMark();}

ULONG FireEtwBGCDrainMark(
    const uint64_t  Objects,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCDrainMark(Objects,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCDrainMark(Objects,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCRevisit(void) {return EventPipeEventEnabledBGCRevisit();}

ULONG FireEtwBGCRevisit(
    const uint64_t  Pages,
    const uint64_t  Objects,
    const unsigned int  IsLarge,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCRevisit(Pages,Objects,IsLarge,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCRevisit(Pages,Objects,IsLarge,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCOverflow_V1(void) {return EventPipeEventEnabledBGCOverflow_V1();}

ULONG FireEtwBGCOverflow_V1(
    const uint64_t  Min,
    const uint64_t  Max,
    const uint64_t  Objects,
    const unsigned int  IsLarge,
    const unsigned short  ClrInstanceID,
    const unsigned int  GenNumber,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCOverflow_V1(Min,Max,Objects,IsLarge,ClrInstanceID,GenNumber,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCOverflow_V1(Min,Max,Objects,IsLarge,ClrInstanceID,GenNumber);
#endif
    return status;
}

BOOL EventEnabledBGCAllocWaitBegin(void) {return EventPipeEventEnabledBGCAllocWaitBegin();}

ULONG FireEtwBGCAllocWaitBegin(
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCAllocWaitBegin(Reason,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCAllocWaitBegin(Reason,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGCAllocWaitEnd(void) {return EventPipeEventEnabledBGCAllocWaitEnd();}

ULONG FireEtwBGCAllocWaitEnd(
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGCAllocWaitEnd(Reason,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGCAllocWaitEnd(Reason,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledGCFullNotify_V1(void) {return EventPipeEventEnabledGCFullNotify_V1();}

ULONG FireEtwGCFullNotify_V1(
    const unsigned int  GenNumber,
    const unsigned int  IsAlloc,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventGCFullNotify_V1(GenNumber,IsAlloc,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatGCFullNotify_V1(GenNumber,IsAlloc,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledBGC1stSweepEnd(void) {return EventPipeEventEnabledBGC1stSweepEnd();}

ULONG FireEtwBGC1stSweepEnd(
    const unsigned int  GenNumber,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventBGC1stSweepEnd(GenNumber,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatBGC1stSweepEnd(GenNumber,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledFailFast(void) {return EventPipeEventEnabledFailFast();}

ULONG FireEtwFailFast(
    const WCHAR*  FailFastUserMessage,
    const void*  FailedEIP,
    const unsigned int  OSExitCode,
    const unsigned int  ClrExitCode,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventFailFast(FailFastUserMessage,FailedEIP,OSExitCode,ClrExitCode,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatFailFast(FailFastUserMessage,FailedEIP,OSExitCode,ClrExitCode,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPrvFinalizeObject(void) {return EventPipeEventEnabledPrvFinalizeObject();}

ULONG FireEtwPrvFinalizeObject(
    const void*  TypeID,
    const void*  ObjectID,
    const unsigned short  ClrInstanceID,
    const WCHAR*  TypeName,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvFinalizeObject(TypeID,ObjectID,ClrInstanceID,TypeName,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvFinalizeObject(TypeID,ObjectID,ClrInstanceID,TypeName);
#endif
    return status;
}

BOOL EventEnabledPrvSetGCHandle(void) {return EventPipeEventEnabledPrvSetGCHandle();}

ULONG FireEtwPrvSetGCHandle(
    const void*  HandleID,
    const void*  ObjectID,
    const unsigned int  Kind,
    const unsigned int  Generation,
    const uint64_t  AppDomainID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvSetGCHandle(HandleID,ObjectID,Kind,Generation,AppDomainID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvSetGCHandle(HandleID,ObjectID,Kind,Generation,AppDomainID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPrvDestroyGCHandle(void) {return EventPipeEventEnabledPrvDestroyGCHandle();}

ULONG FireEtwPrvDestroyGCHandle(
    const void*  HandleID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPrvDestroyGCHandle(HandleID,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPrvDestroyGCHandle(HandleID,ClrInstanceID);
#endif
    return status;
}

BOOL EventEnabledPinPlugAtGCTime(void) {return EventPipeEventEnabledPinPlugAtGCTime();}

ULONG FireEtwPinPlugAtGCTime(
    const void*  PlugStart,
    const void*  PlugEnd,
    const void*  GapBeforeSize,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId,
    const GUID * RelatedActivityId
)
{
    ULONG status = EventPipeWriteEventPinPlugAtGCTime(PlugStart,PlugEnd,GapBeforeSize,ClrInstanceID,ActivityId,RelatedActivityId);
#ifndef TARGET_UNIX
    status &= FireEtXplatPinPlugAtGCTime(PlugStart,PlugEnd,GapBeforeSize,ClrInstanceID);
#endif
    return status;
}

